/**
 * File: TeachingMachine.js
 * ------------------------
 * This program executes a programmed instruction course as discussed
 * in Section 12.5 of the course reader.
 */

function TeachingMachine() {
	let askQuestion = function() {
		console.write(questionXML.innerHTML + "<br/>");
		console.requestInput("> ", checkAnswer);
	};
	
	let checkAnswer = function(response) {
		let answerXML = getAnswerXML(response.toLowerCase());
		if (answerXML === null) {
			console.log("I don't understand that answer.");
		} else {
			let questionID = answerXML.getAttribute("nextQuestion");
			if (questionID === "EXIT") { console.log("All done!"); return; }
			questionXML = document.getElementById(questionID);
		}
		askQuestion();
	};
	
	let getAnswerXML = function(response) {
		let answers = questionXML.getElementsByTagName("answer");
		for (let i = 0; i < answers.length; i++) {
			let answerXML = answers[i];
			let possibility = answers[i].getAttribute("response").toLowerCase();
			if (possibility === response || possibility === "*") return answerXML;
		}
		return null;
	};
	
	let questionXML = document.getElementsByTagName("question")[0];
	askQuestion();
}
